// *****************************************************************
// *                                                               *
// *       Copyright (c) Fast Corporation, 2005                    *
// *                                                               *
// *   All Rights Reserved.  Unpublished rights  reserved  under   *
// *   the copyright laws of the Japan.                            *
// *                                                               *
// *   The software contained on this media  is  proprietary  to   *
// *   and  embodies  the  confidential  technology  of  Fast      *
// *   Corporation.  Possession, use,  duplication  or             *
// *   dissemination of the software and media is authorized only  *
// *   pursuant to a valid written license from Fast Corporation.  *
// *                                                               *
// *****************************************************************

// -------------------------------------------------------------------
// FVX Sample Program
// 
//
// 쐬 : K.Yakushinji
//    : 2005/08/08 
//
//-------------------------------------------------------------------

// CircleDensityDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include <cmath>


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎgĂ CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// bZ[W nh܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCircleDensityDlg _CAO

CCircleDensityDlg::CCircleDensityDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCircleDensityDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCircleDensityDlg)
		// : ̈ʒu ClassWizard ɂăȍǉ܂B
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pGraph = NULL;
	m_PI = 3.14159265358979;
	m_blnVideoOpened = false;
}

void CCircleDensityDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCircleDensityDlg)
		// : ̏ꏊɂ ClassWizard ɂ DDX  DDV ̌Ăяoǉ܂B
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCircleDensityDlg, CDialog)
	//{{AFX_MSG_MAP(CCircleDensityDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_SIZE()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_LOADIMAGE, OnLoadimage)
	ON_BN_CLICKED(IDC_SAVEIMAGE, OnSaveimage)
	ON_BN_CLICKED(IDC_SETCIRCLE, OnSetcircle)
	ON_BN_CLICKED(IDC_GRAB, OnGrab)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCircleDensityDlg bZ[W nh

BOOL CCircleDensityDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[ڂVXe j[֒ǉ܂B

	// IDM_ABOUTBOX ̓R}h j[͈̔͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	// TODO: ʂȏs͂̏ꏊɒǉĂB
	/* -------------------------------------------------------------------------------- */
	// FvxSample 
	CLicenceDlg dlg;
	CConfFileDlg fdlg;

	// CZXʂ̕\
	if (dlg.DoModal() == IDOK){

		//Ӂ
		// ߂COM̏sƂYȂłB
		CoInitialize(NULL);
		CWnd *pwnd ;
		IUnknown *p_unknown;
		long err_no ;

		// _CAOɓ\tĂFvxDisplayEx̃CX^X擾AX}[g|C^Ɋt܂B
		pwnd = GetDlgItem(IDC_FVXDISPLAYEX1);		// FvxDisplayEx̃nh擾
		p_unknown = pwnd->GetControlUnknown();		// Rg[̎IUnknownC^[tFCX擾
		p_unknown->QueryInterface(__uuidof(IFvxDisplayEx2Ptr),(void**)&m_FvxDisplayEx);

		// eFvxRg[̃CX^X𐶐܂B
		// w肷NXԈႦȂ悤ӂĂB
		m_FvxFileAccess.CreateInstance( __uuidof( FvxFileAccess ) ); 
		m_FvxImage1.CreateInstance( __uuidof( FvxImage ) ); 
		m_FvxVideo.CreateInstance( __uuidof( FvxVideo ) ); 
		m_FvxROI.CreateInstance( __uuidof( FvxROI ) ); 
		m_TestCircle.CreateInstance( __uuidof( FvCircle ) ); 

		// J荞ݖ
		GetDlgItem(IDC_GRAB)->EnableWindow(FALSE);

		// fBXvC̏
		m_FvxDisplayEx->CreateDisplay(1,0);

		// 摜̕\
		m_FvxDisplayEx->DrawImage(m_FvxImage1);

		// ~̏lݒ
		m_TestCircle->Putx( 337 );
		m_TestCircle->Puty( 199 );
		m_TestCircle->Putradius( 92 );

		// I[oCNA
		m_FvxDisplayEx->ClearOverlay(-1);
    
		// fBXvC
	    m_pGraph = new CGraph();
		m_pGraph->Create( IDD_GRAPH , GetDesktopWindow() );
		m_pGraph->ShowWindow( SW_HIDE );
		
		DrawTestCircle();
		SetGraph();
		
		// rfIݒt@C̑I
		fdlg.DoModal();

		if ( fdlg.m_check == FALSE ) {
			
		    // rfIݒt@CR|[lgɐݒ
 			m_FvxVideo->PutVideoConfFile( _bstr_t( fdlg.m_conffile ) );

			// rfIfoCXI[v
			try {

				m_FvxVideo->OpenDevice();

			} catch( _com_error ) {
			
				m_FvxVideo->GetErrReport( &err_no );
				MessageBox("rfIfoCX̃I[vɎs܂\r\n摜t@Ĉ݂̗pɂȂ܂B" , "G[" , MB_ICONWARNING | MB_OK );
				return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
			}

			// VideoConfFile̕ύXAOpenDevicesƁAgK[[h̕ύX܂
			// ̂߁AЃLv`{[hFVC02ł350ms̃ZbgAbv^CKvɂȂ܂
			// {vOł͊ȗ̂߂ɁAꗥ350ms̃ZbgAbv^CmۂĂ܂A
			// g̃Lv`{[hɍ킹ĕύXĂB
			::Sleep(350);

            // GrabSync/GrabASync\bhłImageTCY̕ύXs܂̂ŁA
            // 炩ChangeImageSize\bhɂImagẽTCYύXĂ
            // i荞݃TCYImagẽTCYႤꍇG[ɂȂ܂j
			m_FvxVideo->ChangeImageSize(m_FvxImage1);

			try	{

				// 捞
				m_FvxVideo->GrabSync(m_FvxImage1);

			} catch(_com_error ) {
			
				m_FvxVideo->GetErrReport( &err_no );
				MessageBox("rfI̎捞Ɏs܂\r\n摜t@Ĉ݂̗pɂȂ܂B" , "G[" , MB_ICONWARNING | MB_OK );
				return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B

			}

			// J荞ݗL
			GetDlgItem(IDC_GRAB)->EnableWindow(TRUE);
			// rfIfoCX̏ԂL
			m_blnVideoOpened = true;

		}

		// 摜̕\
		m_FvxDisplayEx->DrawImage(m_FvxImage1);

		// I[oCNA
		m_FvxDisplayEx->ClearOverlay(-1);
    
		DrawTestCircle();
		SetGraph();

	}else{

		// ӂĂ炦Ȃ瑦I
		EndDialog( IDCANCEL );
	}

	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B

}

void CCircleDensityDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CCircleDensityDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
		m_pGraph->ShowWindow( SW_SHOW );
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CCircleDensityDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BOOL CCircleDensityDlg::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	if(pMsg->message == WM_KEYDOWN)
	{
		switch( pMsg->wParam )
		{
			case VK_RETURN:
			case VK_ESCAPE:
				return false;
		}
	}
	
	return CDialog::PreTranslateMessage(pMsg);
}

void CCircleDensityDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	if (IsIconic() == 0 ) {

		if ( m_FvxDisplayEx != NULL ){

			CWnd *pwnd;
			CRect rect;

			pwnd = GetDlgItem( IDC_FVXDISPLAYEX1 );
			pwnd->GetWindowRect( rect );

			// XN[WNCAgWɕϊ
			ScreenToClient( rect );

			// FvxDisplayEx̃TCYύX
			pwnd->MoveWindow( rect.left , rect.top, cx - (rect.left + 20) , cy - (rect.top + 20) , TRUE );
		}
	}
	
}

void CCircleDensityDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	// fBXvCJ
	if ( m_pGraph != NULL ) {
		m_pGraph->DestroyWindow();
		delete m_pGraph;
		m_pGraph = NULL;
	}

	// rfIfoCXI[vĂꍇ̓N[Y܂
	if ( m_blnVideoOpened == true ) {
		m_FvxVideo->CloseDevice();	
	}
		
}

// 摜t@CǍ
void CCircleDensityDlg::OnLoadimage() 
{
	
	// R_CAONX̐
	char szFilters[]="bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg (TRUE , "bmp", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){
		m_FvxFileAccess->PutFilePath( _bstr_t( cFileDlg.GetPathName() ) );

		try {
		
			m_FvxFileAccess->LoadBitmap( m_FvxImage1 );
		
		} catch(_com_error ) {

			long lngErr;
			CString cStr;

			m_FvxFileAccess->GetErrReport( &lngErr );
			cStr.Format("Ǎ݂Ɏs܂Berr_no = %d", lngErr );
			MessageBox(cStr,"G[", MB_ICONWARNING | MB_OK);
			return;
		}

		// 摜^Cv`FbN
		if (( m_FvxImage1->GetImageType ()!=imageGray ) || ( m_FvxImage1->GetBitPerPixel()!=8 )) {

			MessageBox("8bitOC̉摜ł͂܂","G[", MB_ICONWARNING | MB_OK);

            m_FvxImage1->PutBitPerPixel( 8 );
            m_FvxImage1->PutImageType( imageGray );
            m_FvxImage1->PutImageWidth( 512 );
            m_FvxImage1->PutImageHeight( 480 );

		}

        m_FvxDisplayEx->DrawImage( m_FvxImage1 );
	}

	 SetGraph();
}

// 摜t@Cۑ
void CCircleDensityDlg::OnSaveimage() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	char szFilters[]="bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg(FALSE , "bmp", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){

		m_FvxFileAccess->PutFilePath ( _bstr_t( cFileDlg.GetPathName() ));

		try {
		
			m_FvxFileAccess->SaveBitmap( m_FvxImage1 );
		
		} catch(_com_error ) {

			long lngErr;
			CString cStr;

			m_FvxFileAccess->GetErrReport( &lngErr );
			cStr.Format("ۑɎs܂Berr_no = %d", lngErr );
			MessageBox(cStr , "G[", MB_ICONWARNING | MB_OK);
			return;
		}
	}
	
}

// ~̔Zx擾OttH[ւ̃f[^i[
void CCircleDensityDlg::SetGraph()
{

	int i = 0;
    long lngDensity = 0;
    IFvPointPtr pPoint(__uuidof(FvPoint));
    
    for ( i = 0 ; i <=360 ; i++ ) {
        // ~̍WvZ
        // ㉺̍WnʂƂ͋tȂ̂ŁA]tɂĈʂɍ킹܂B
		pPoint->Putx( m_TestCircle->Getx() + (m_TestCircle->Getradius() * cos(-i * m_PI / 180)));
        pPoint->Puty( m_TestCircle->Gety() + (m_TestCircle->Getradius() * sin(-i * m_PI / 180)));
        
        // NbsO
        if (( pPoint->Getx() >= 0 )&& ( pPoint->Getx() < m_FvxImage1->GetImageWidth()) 
			&& ( pPoint->Gety() >= 0 ) && ( pPoint->Gety() < m_FvxImage1->GetImageHeight()) ) {
            
            // Zxl擾āAOttH[Ɋi[
            m_FvxImage1->GetPixel( pPoint, &lngDensity ,0);
            m_pGraph->SetData[i] = (BYTE)lngDensity;
        } else {
            // 摜͂ݏoĂƂ͔Zx0 Ƃ
            m_pGraph->SetData[i] = (BYTE)0;
		}
	}
        
    // Ot̍XV
    m_pGraph->DrawGraph();
}


// ~̐ݒ
void CCircleDensityDlg::OnSetcircle() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
    long lngOK = 0;
    double dblTemp = 0;
    
    m_FvxROI->SetCircle( m_TestCircle );
    
    // FvxROIgď͈͑I_CAOo܂
    m_FvxROI->PutUseCircle( TRUE );
    m_FvxROI->PutUseRectangle( FALSE );
    m_FvxROI->PutUsePoint( FALSE );
    m_FvxROI->MakeROIDialog( m_FvxImage1, &lngOK );
    
    if (( lngOK == 1 ) && ( m_FvxROI->GetCheckCircle() == 1)) {
        m_FvxROI->GetCircle( m_TestCircle );
	}
			
    m_FvxDisplayEx->ClearOverlay(-1);
    DrawTestCircle();
    SetGraph();
	
}

//@~̕`
void CCircleDensityDlg::DrawTestCircle()
{

    IFvLineSegmentPtr pLineSeg(__uuidof(FvLineSegment));
    
    m_FvxDisplayEx->PutPenColor(RGB(255, 0, 0));
    m_FvxDisplayEx->DrawData( 0, m_TestCircle );
    
    // Sɏ\}[N
    pLineSeg->Putxs( m_TestCircle->Getx() );
    pLineSeg->Putxe( m_TestCircle->Getx() );
    pLineSeg->Putys( m_TestCircle->Gety() - 5 );
    pLineSeg->Putye( m_TestCircle->Gety() + 5 );
    m_FvxDisplayEx->DrawData( 0, pLineSeg );
    pLineSeg->Putxs( m_TestCircle->Getx() - 5 );
    pLineSeg->Putxe( m_TestCircle->Getx() + 5 );
    pLineSeg->Putys( m_TestCircle->Gety() );
    pLineSeg->Putye( m_TestCircle->Gety() );
    m_FvxDisplayEx->DrawData( 0, pLineSeg );

    // S0x̐
    pLineSeg->Putxs( m_TestCircle->Getx() );
    pLineSeg->Putxe( m_TestCircle->Getx() + m_TestCircle->Getradius() );
    pLineSeg->Putys( m_TestCircle->Gety() );
    pLineSeg->Putye( m_TestCircle->Gety() );
    m_FvxDisplayEx->DrawData( 0, pLineSeg );
    
}

void CCircleDensityDlg::OnGrab() 
{
    // 摜t@Cǂݍ݂ɂāA摜TCY
    // ύXĂ\邽߁AChangeImageSizes܂B
	// 摜TCYύX\ꍇ́AɈxsΖL܂B
    m_FvxVideo->ChangeImageSize( m_FvxImage1 );
    
    // 捞
    m_FvxVideo->GrabSync( m_FvxImage1 );
    // 荞񂾉摜ʂɕ\
    m_FvxDisplayEx->DrawImage( m_FvxImage1 );
    
    SetGraph();
}
