// *****************************************************************
// *                                                               *
// *       Copyright (c) Fast Corporation, 2005                    *
// *                                                               *
// *   All Rights Reserved.  Unpublished rights  reserved  under   *
// *   the copyright laws of the Japan.                            *
// *                                                               *
// *   The software contained on this media  is  proprietary  to   *
// *   and  embodies  the  confidential  technology  of  Fast      *
// *   Corporation.  Possession, use,  duplication  or             *
// *   dissemination of the software and media is authorized only  *
// *   pursuant to a valid written license from Fast Corporation.  *
// *                                                               *
// *****************************************************************

// -------------------------------------------------------------------
// FVX Sample Program
// 
//
// 쐬 : K.Yakushinji
//    : 2005/08/08 
//
//-------------------------------------------------------------------

// Graph.cpp : Cve[V t@C
//

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGraph _CAO


CGraph::CGraph(CWnd* pParent /*=NULL*/)
	: CDialog(CGraph::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGraph)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_INIT
}


void CGraph::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGraph)
	DDX_Control(pDX, IDC_PICGRAPH, m_graph);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CGraph, CDialog)
	//{{AFX_MSG_MAP(CGraph)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGraph bZ[W nh

void CGraph::OnPaint() 
{

	if (IsIconic()) {
		//------
	} else {
		CPaintDC dc(GetDlgItem(IDC_PICGRAPH)); // `p̃foCX ReLXg

		// `̈NA
		RECT rect;

		GetDlgItem(IDC_PICGRAPH)->GetClientRect(&rect);  
		dc.FillSolidRect(&rect,RGB(255,255,255));
		
		// : px(0`360)
		// : Zx(0`255)
		// Oẗ(40,20)-(400,276)
		// x
		CPoint pPoint[2];
		pPoint[0].x=30; 
		pPoint[0].y=276; 
		pPoint[1].x=410; 
		pPoint[1].y=276; 
		dc.Polyline(pPoint,2);
		
		CString szStr;
		for(int i=45;i<=360;i=i+45 ) {
			pPoint[0].x=40+i; 
			pPoint[0].y=271; 
			pPoint[1].x=40+i; 
			pPoint[1].y=276; 
			dc.Polyline(pPoint,2);
			szStr.Format("%d",i);
			dc.TextOut(30 + i,280,szStr);
		}

		szStr="px(x)";
		dc.TextOut(200,300,szStr);
        
		// y
		pPoint[0].x=40; 
		pPoint[0].y=10; 
		pPoint[1].x=40; 
		pPoint[1].y=296; 
		dc.Polyline(pPoint,2);

		pPoint[0].x=35; 
		pPoint[0].y=21; 
		pPoint[1].x=40; 
		pPoint[1].y=21; 
		dc.Polyline(pPoint,2);

		pPoint[0].x=35; 
		pPoint[0].y=148; 
		pPoint[1].x=40; 
		pPoint[1].y=148; 
		dc.Polyline(pPoint,2);
  
		szStr="0";
		dc.TextOut(30,280,szStr);
		szStr="255";
		dc.TextOut(15,15,szStr);
    
		szStr="Z";
		dc.TextOut(10,138,szStr);

		szStr="x";
		dc.TextOut(10,158,szStr);

		// f[^`
		for( i = 1; i<=359 ;i++ ) {
			pPoint[0].x=40+(i-1); 
			pPoint[0].y=276-SetData[i-1]; 
			pPoint[1].x=40+i; 
			pPoint[1].y=276-SetData[i]; 
			dc.Polyline(pPoint,2);
		}

		CDialog::OnPaint();
	}
}

void CGraph::DrawGraph()
{
	RECT rect;

	GetDlgItem(IDC_PICGRAPH)->GetClientRect(&rect);  
	// \
    ::InvalidateRect( GetSafeHwnd(), &rect,  FALSE ); 
}
